using MRIgeneralizedBloch
using Test

@testset "Greens_Interpolation" begin
    include("Greens_Interpolation.jl")
end

@testset "apply_hamiltonian_gbloch!" begin
    for i = 1:10 # test different random initializations
        include("gBloch_Hamiltonian.jl")
    end
end

@testset "apply_hamiltonian_freeprecession!" begin
    for i = 1:10 # test different random initializations
        include("FreePrecession_Hamiltonian.jl")
    end
end

@testset "apply_hamiltonian_graham_superlorentzian!" begin
    for i = 1:10 # test different random initializations
        include("Graham_Hamiltonian_superLorentzian.jl")
    end
end

@testset "Linear_Approximation" begin
    include("Linear_Approximation.jl")
end

@testset "apply_hamiltonian_gbloch! gradients" begin
    include("gBloch_Hamiltonian_Gradients.jl")
end

@testset "apply_hamiltonian_freeprecession! gradients" begin
    include("FreePrecession_Hamiltonian_Gradients.jl")
end

@testset "Linaer_Approx gradients" begin
    include("Linaer_Approx_Gradients.jl")
end

@testset "apply_hamiltonian_graham_superlorentzian! gradients" begin
    include("Graham_Hamiltonian_Gradients.jl")
end

@testset "calculate_magnetization_n_signal" begin
    include("calculate_magnetization_n_signal.jl")
end